function rgb = makeRGB(m,cmap,indIn,cdiv,incol)
% map m linearly onto cmap. Lowest m to cmap(1,:),
% maximum to cmap(end-1,:). 
% m(indIn) gets cmap(end,:)=incol (default black)
% if cdiv given colors are repeated over outside points

if(nargin<3)
    indIn = [];
end
if(nargin<4 | isempty(cdiv))
    cdiv = 1;
end
if(nargin<5 | isempty(incol))
    incol = [0 0 0];
end

[sz1 sz2] = size(m);

% find interior indices
indOut = 1:length(m(:));
indOut(indIn) = [];
mo = m(indOut);
% rescale 0-1
mo = mo-min(mo);
mo = mo/max(mo);
% last color reserved
ncols = size(cmap,1)-1;
% generate ncuse integers for color, then take mod
ncuse = round(ncols/cdiv);
mo = mo*(ncuse-1);
mo = uint16(mo) + 1;
% now mo has values 1,...,ncuse. Recyle.
mo = mod(mo-1,ncols)+1;
m = uint16(m);
m(indOut) = mo;
% interior:
m(indIn) = ncols+1;
cmap(end,:) = incol;
rgb = cmap(m,:);
rgb = reshape(rgb,sz1,sz2,3);

