function [m md mdd] = procRegion(c,nmax,R,pid,fc,fcp)

m = ones(size(c))*(nmax+1);
md = zeros(size(c));
mdd = 0*md;
z = 0*c;
dz = ones(size(c));
ddz = 0*c;
if(nargin>4 && ~isempty(fc))
    c = fc(c);
end
if(nargin>5 && ~isempty(fcp))
    dz = fcp(c);
else
    fcp = @(x) 1;
end

% only these indices need work
% z,dz,ddz,c in loop vectors of just these indices
indToDo = 1:length(m(:));
nToDo = length(indToDo);
nToDo0 = nToDo;

for k = 1:nmax
    if(mod(k,100)==0)
        fprintf('p%d:%d/%d,R %5.2f%%\n',pid,k,nmax,nToDo/nToDo0*100);
    end
    ddz = 2*dz.^2 +2*z.*ddz;
    dz = 2*z .* dz + fcp(c);
    z = z.^2 + c;    
    zz = abs(z);
    % find new indices that have escaped and put in m and md
    indDone = find(zz>=R); % index into indToDo
    indDoneM = indToDo(indDone); % index into m
            
    m(indDoneM) = k-log(log(zz(indDone)))/log(2);
    %G/G', G = exp(-log(2)*m)
    md(indDoneM) = log(zz(indDone)) .* abs(zz(indDone)./dz(indDone));
    %G'/G''=1/(log(G'))' 
    mdd(indDoneM) = zz(indDone).*abs(dz(indDone))./abs(z(indDone).*ddz(indDone)-dz(indDone).^2);
    
    indToDo(indDone) = [];
    if(length(indToDo)==0)
        break;
    end
    ir = 1:length(c(:));
    ir(indDone) = [];
    c = c(ir);
    z = z(ir);
    dz = dz(ir);
    ddz = ddz(ir);
    nToDo = length(ir);
end
